<script setup lang="ts">
import { ref } from 'vue'
import { useI18n } from 'vue-i18n'
import { useClipboard } from '@vueuse/core'
import { type RestErrorBoxOptions } from './RestErrorBox'

type HTMLButtonRef = InstanceType<typeof HTMLButtonElement>

// using
const { t } = useI18n({
	messages: {
		en: {
			close: "Close",
			caption: "Warning",
			copy: "Copy",
			text: "If you want to report error, please tap 'Copy' and bring the message, too.",
		},
		th: {
			close: "ปิด",
			caption: "แจ้งเตือน",
			copy: "สำเนา",
			text: "หากคุณต้องการแจ้งปัญหา กรุณากดปุ่ม 'สำเนา' แล้วนำข้อความ ไปแสดงด้วย",
		},
	},
})

// states
const defaultOptions = ref(<RestErrorBoxOptions>{
	content: "",
	alternateFocus: false,
	barrierDismissible: false,
	barrierBackground: '#9009',
	titleBackground: '#c00',
	titleColor: '#fff',
	icon: 'warning',
	iconColor: '#c00',
	rightIcon: true,
})
const options = ref(<RestErrorBoxOptions>{
})
const opened = ref(<boolean>false)

// support states
const orderIcon = ref('')
const orderText = ref('')
const timer = ref(<any>null)
const firstKey = ref(<HTMLButtonRef | null>null)
const lastKey = ref(<HTMLButtonRef | null>null)
const closeButton = ref(<HTMLButtonRef | null>null)
const copyButton = ref(<HTMLButtonRef | null>null)

const { text, copy, copied, isSupported } = useClipboard({ source: options.value.reportText ?? '' })

// ----------------------------------------------------------------------

// exposed API
defineExpose({

	/**
	 * Set defaults options, before calling open().
	 */
	setDefaults: function (o: RestErrorBoxOptions): void {
		defaultOptions.value = { ...o }
		console.log(`RestErrorBox.defaultOptions: ${JSON.stringify(defaultOptions.value, null, 2)}`)
	},

	/**
	 * Checks if the REST error box is opened or not.
	 */
	isOpen: function (): boolean {
		return opened.value
	},

	/**
	 * Opens REST error box.
	 * Return true if the REST error box is opened successfully.
	 * Otherwise, it is false.
	 */
	open: function (o: RestErrorBoxOptions): boolean {
		return openThis(o)
	},

	/**
	 * Closes the REST error box.
	 */
	close: function (result: boolean): void {
		closeThis(result)
	},

})

// ----------------------------------------------------------------------

function onKeyDownEscape(event: KeyboardEvent): void {
	if (event.key === 'Escape') {
		closeThis(false)
		event.preventDefault()
	}
}

function onKeyDownButton(event: KeyboardEvent): void {
	if (event.key === 'Tab') {
		if (event.shiftKey) {
			if (event.target == firstKey.value) {
				lastKey.value?.focus()
				event.preventDefault()
			}
		}
		else {
			if (event.target == lastKey.value) {
				firstKey.value?.focus()
				event.preventDefault()
			}
		}
	}
}

function shader(): void {
	if (opened.value && options.value.barrierDismissible) {
		closeThis(false)
	}
}

function nl2br(s: string): string {
	return s.replace(/\r\n|\n|\r/gm, '<br/>')
}

function openThis(o: RestErrorBoxOptions): boolean {
	// checks if it already opened
	if (opened.value) {
		return false
	}

	options.value = { ...defaultOptions.value }
	options.value.content = nl2br(o.content)
	if (typeof o.alternateFocus === 'boolean')
		options.value.alternateFocus = o.alternateFocus
	if (typeof o.barrierDismissible === 'boolean')
		options.value.barrierDismissible = o.barrierDismissible
	if (typeof o.barrierBackground === 'string')
		options.value.barrierBackground = o.barrierBackground
	if (typeof o.titleBackground === 'string')
		options.value.titleBackground = o.titleBackground
	if (typeof o.titleColor === 'string')
		options.value.titleColor = o.titleColor
	if (typeof o.icon === 'string')
		options.value.icon = o.icon
	if (typeof o.iconColor === 'string')
		options.value.iconColor = o.iconColor
	if (typeof o.rightIcon === 'boolean')
		options.value.rightIcon = o.rightIcon
	options.value.reportText = o.reportText ?? null
	options.value.callback = o.callback
	opened.value = true
	console.log(`RestErrorBox.options: ${JSON.stringify(options.value, null, 2)}`)
	window.addEventListener('keydown', onKeyDownEscape)

	if (options.value.rightIcon) {
		orderIcon.value = 'order-2'
		orderText.value = 'order-1'
	}
	else {
		orderIcon.value = 'order-1'
		orderText.value = 'order-2'
	}

	timer.value = setTimeout(() => {
		firstKey.value = closeButton.value
		lastKey.value = copyButton.value
		firstKey.value?.focus()
	}, 0)

	return true
}

function closeThis(result: boolean): void {
	if (opened.value) {
		clearTimeout(timer.value)
		window.removeEventListener('keydown', onKeyDownEscape)
		opened.value = false
		if (options.value.callback)
			options.value.callback(result)
	}
}

function copyThis(): void {
	copy(options.value.reportText ?? '')
}
</script>


<style scoped>
#container {
	position: fixed;
	width: 100%;
	height: 100%;
	left: 0px;
	top: 0px;
}

#center {
	position: absolute;
	left: 50%;
	top: 50%;
	width: 60%;
	transform: translate(-50%, -50%);
}

#dialog {
	border-radius: 1rem;
	border: 4px;
	box-shadow: 0.25rem 0.25rem #666c;
}

#caption {
	border-top-left-radius: 1rem;
	border-top-right-radius: 1rem;
	padding: 0.75rem 1rem;
	font-size: 1.125rem;
	font-weight: bold;
	line-height: 1.75rem;
}

#content {
	display: flex;
	align-items: flex-start;
	gap: 1rem;
	padding: 1rem;
	background: #fff;
	color: #000;
}

#buttons {
	border-bottom-left-radius: 1rem;
	border-bottom-right-radius: 1rem;
	padding: 1rem;
	text-align: right;
	background: #e0e0e0;
}

#buttons button {
	display: inline-flex;
	align-items: center;
	padding: 0.25rem 0.5rem;
	margin: 0 0 0 0.75rem;
	cursor: pointer;
}

#buttons button>i {
	width: 1.5rem;
	height: 1.5rem;
	margin-right: 0.25rem;
}

#report {
	display: flex;
	align-items: flex-start;
	gap: 1rem;
	font-size: 90%;
	padding: 1rem;
	background: #fd8;
	color: #000;
}

#report button {
	display: inline-flex;
	align-items: center;
	padding: 0.25rem 0.5rem;
	margin: 0 0 0 0.75rem;
	cursor: pointer;
}

#report button>i {
	width: 1.5rem;
	height: 1.5rem;
	margin-right: 0.25rem;
}

.order-1 {
	order: 0;
}

.order-2 {
	order: 1;
}

.animate {
	animation-duration: 0.5s;
	animation-name: in;
}

@keyframes in {
	from {
		opacity: 0;
	}

	to {
		opacity: 1;
	}
}

@media (min-width: 1024px) {
	#center {
		width: 50%;
	}
}

@media (min-width: 1280px) {
	#center {
		width: 40%;
	}
}
</style>


<template>
	<!-- background -->
	<div v-if="opened" id="container" :style="{ background: options.barrierBackground }" @click.prevent.stop="shader">
		<!-- the centered dialog box-->
		<div id="center" class="animate" @click.prevent.stop="">
			<!-- dialog box -->
			<div id="dialog">
				<!-- caption -->
				<div id="caption" :style="{ background: options.titleBackground, color: options.titleColor }">
					{{ t('caption') }}
				</div>

				<!-- content -->
				<div id="content">
					<div style="flex: 0 1 auto; margin-top: 0.25rem" :class="orderIcon" :hidden="!options.icon">
						<i class="material-symbols-outlined" style="font-size: 3rem"
							:style="{ color: options.iconColor }">{{ options.icon }}</i>
					</div>
					<div style="flex: 1 1 auto;" :class="orderText" v-html="options.content" />
				</div>

				<!-- report bug -->
				<div v-if="options.reportText" id="report">
					<div style="flex: 1 1 auto">
						<label>{{ t('text') }}</label>
					</div>
					<div style="flex: 0 1 auto">
						<button ref="copyButton" @click.prevent="copyThis()" @keydown="onKeyDownButton">
							<i class="material-symbols-outlined" :style="{ color: options.iconColor }">content_copy</i>
							<span>{{ t('copy') }}</span>
						</button>
					</div>
				</div>

				<!-- buttons -->
				<div id="buttons" ref="actions">
					<button ref="closeButton" @click.prevent="closeThis(false)" @keydown="onKeyDownButton">
						<i class="material-symbols-outlined" :style="{ color: options.iconColor }">close</i>
						<span>{{ t('close') }}</span>
					</button>
				</div>
			</div>
		</div>
	</div>
</template>
